
<CsoundSynthesizer>
<CsOptions>

</CsOptions>
<CsInstruments>
sr = 44100
ksmps = 50
nchnls = 2

/*| genOffset: 100 |*/

#define VOLUME #70000#
#define BANK #0#
#define SOUNDFONT #NylonGuitar1.SF2#
#define PRESET #0#

giengine  fluidEngine
isfnum    fluidLoad "$SOUNDFONT", giengine
          fluidProgramSelect giengine, 1, isfnum, $BANK, $PRESET
          fluidProgramSelect giengine, 2, isfnum, $BANK, $PRESET
          fluidProgramSelect giengine, 3, isfnum, $BANK, $PRESET
          fluidProgramSelect giengine, 4, isfnum, $BANK, $PRESET
          fluidProgramSelect giengine, 5, isfnum, $BANK, $PRESET
          fluidProgramSelect giengine, 6, isfnum, $BANK, $PRESET
          fluidProgramSelect giengine, 7, isfnum, $BANK, $PRESET
          fluidProgramSelect giengine, 8, isfnum, $BANK, $PRESET
          fluidProgramSelect giengine, 9, isfnum, $BANK, $PRESET
          fluidProgramSelect giengine, 10, isfnum, $BANK, $PRESET
          fluidProgramSelect giengine, 11, isfnum, $BANK, $PRESET
          fluidProgramSelect giengine, 12, isfnum, $BANK, $PRESET
          fluidProgramSelect giengine, 13, isfnum, $BANK, $PRESET
          fluidProgramSelect giengine, 14, isfnum, $BANK, $PRESET
          fluidProgramSelect giengine, 15, isfnum, $BANK, $PRESET
          fluidProgramSelect giengine, 16, isfnum, $BANK, $PRESET

  gipbrange init      24


instr MidiSynth
/*| 
((dispatchField: 7)
 (dispatchGap: 0.1)
 (pitchField: 4)
 (pitchFormat: cps)
 (pitchInflexionField: 6)
 (ampField: 5)
 (ampMin:max: (0 127))
 (iTemplate: "i 1 0 0.5 440 80 0"))
|*/
            ;; p4   base pitch (cps)
            ;; p5   velocity
            ;; p6   pitch bend envelope over p3 (in cents)
            ;; p7   MIDI channel

	    fluidControl  giengine, 176, p7, 100, 0
	    fluidControl  giengine, 176, p7, 101, 0
	    fluidControl  giengine, 176, p7, 6, gipbrange  

  imfloat   =  (17.31234049066757 * log(p4)) - 36.376316562296
  ikey      =  round(imfloat)
  ipbend    =  (imfloat - ikey) * 100

  ivel      init      p5

  kpbend    =  0
if p6=0 goto noEnvelope
  kndx      line      0, p3, 1
  kpbend    table     kndx, p6, 1 
noEnvelope:

  kfullbend =  round(8192 * (1 + 0.01 * (ipbend + kpbend) / gipbrange))
  kdata1    =  kfullbend & 127
  kdata2    =  kfullbend >> 7
	    fluidControl  giengine, 224, p7, kdata1, kdata2  
            fluidNote   giengine, p7, ikey, ivel
endin

instr FluidOutput
/*|effect i "FluidOutput" 0 1|*/
  imvol	    init      $VOLUME
  asigl, asigr fluidOut	  giengine
	    outs      asigl * imvol, asigr * imvol
endin
		
</CsInstruments>
<CsScore>
/*| header |*/
/*| header end |*/

/*| effects |*/
i "FluidOutput" 0 6.5 
/*| effects end |*/
i "MidiSynth" 0.0 0.5 261.626 63.5 0 1 
i "MidiSynth" 0.5 0.5 277.183 63.5 0 2 
i "MidiSynth" 1.0 0.5 293.665 63.5 0 1 
i "MidiSynth" 1.5 0.5 311.127 63.5 0 2 
i "MidiSynth" 2.0 0.5 329.628 63.5 0 1 
i "MidiSynth" 2.5 0.5 349.228 63.5 0 2 
i "MidiSynth" 3.0 0.5 369.994 63.5 0 1 
i "MidiSynth" 3.5 0.5 391.995 63.5 0 2 
i "MidiSynth" 4.0 0.5 415.305 63.5 0 1 
i "MidiSynth" 4.5 0.5 440.0 63.5 0 2 
i "MidiSynth" 5.0 0.5 466.164 63.5 0 1 
e 7.5
</CsScore>
</CsoundSynthesizer>
